# Twitter-Bitly data collection tool
![Image](https://liu.se/-/media/liu/2016/11/15/liu-primar-svart.png?la=sv-se&w=360&hash=C01824C571D1F0CF5054BE2B92969EBF8559761A
)

****************************************

If you use our datafiles and/or software in your research, please cite our ASONAM 2019 paper in your research:

Jesper Holmstrom, Daniel Jonsson, Filip Polbratt, Olav Nilsson, Linnea Lundstrom, Sebastian Ragnarsson, Anton Forsberg, Karl Andersson, and Niklas Carlsson. "Do we Read what we Share? Analyzing the Click Dynamic of News Articles Shared on Twitter", Proc. IEEE/ACM International Conference on Advances in Social Networks Analysis and Mining (ASONAM), Vancouver, Canada, Aug. 2019.

****************************************


The current version of the program works as follows:

### Main.py
Runner of the program, settings as number of runs, timeouts, sleeplenths etc, also after-collection settings as classifier, excel saving etc.
If changing of updating intervals, gathering periods etc, you need to change in two places.

### bitlyRunner.py

Reads file names from a file (which tweets-runner stores them in). 
The file names are the twitter files to process. For each such file,
this program runs a set of X (in this case 100 (not currently true)) randomly selected tweets
and as many news tweets (no random tweets at the moment, only news). The program asks bitly for long URL, clicks per
country and clicks per referrer. Also saves identifiers (bitly user, bitly
link, and tweet ID) global clicks and clicks made by user.

### bitlyFinder.py

Here you need to fill in your keys to the twitter api.

```python
access_token = 'insert'
access_token_secret = 'insert'
consumer_key = 'insert'
consumer_secret = 'insert'
```

### bitlyDatahandler.py

Also needs api keys:

```python
login = 'insert'
api_key = 'insert'
generic_token = 'insert'
```

### tweetsRunner.py
This file collects the tweets, with the help of some help files.

### Helper files
bitlyextractor and bitlydatahandler are helper filers. 
A directory "data" is used for the data and a sub-directory "tweets" in "data" for the tweets.

### Other files:

__htmlToText.py__ extract the news article from an url

__naiveBayesTrainer.py__ trains a text classifier to classify text as fake or real

__naiveBayesPipeline.py__ classifies the text as fake or real.

__updateClicksAllInOneSheet.Py__ writes data to excel file when collection is completed



## Installation

Use the package manager [pip](https://pip.pypa.io/en/stable/) to install all the packages used in this project.

```bash
pip install foobar
```
Note: We recommend installing into a virtual python environment, especially if you use macOS. From our experience there is a lot of version-mismatch since python's packages management is quite unstructured. The versions below might not work anymore depending on python versions etc. Also different versions worked on different OS.
 
****************************************
__xlwt__ (excel)

__beautifulsoup4__ (webscraper)

__tweepy__ (twitter API)

__bitly_api__ (bitly api)

For the naive bayes classifier you need several packages:

__numpy__ ( get version 1.11 or later. Special case for Windows, see below)

__pandas__ (use pip to install. Requires numpy)

__Scipy__ (Use pip to install if not on Windows, get version 0.19.0. Requires numpy)

__scikit-learn__ (Use pip to install if not on Windows, get version 0.18.1. Requires numpy and Scipy)

****************************************
These two are a little bit tricky to install on Windows due to you need a special Windows version, you can find the packeges
on this [page](http://www.lfd.uci.edu/~gohlke/pythonlibs/).
You may also need to install numpy-1.11+mkl from the same page.
Make sure you have Microsoft Visual C++ 2008 redistributable package.
Make sure that you get a version that is compatible with: Your operating system, your version of Python and version of package as specified above.


__Scipy__ (for example: scikit_learn‑0.18.1‑cp27‑cp27m‑win_amd64.whl for a computer running a 64-bit version of Windows on x86-64 and Python 2.7)
scikit-learn (for example: scipy‑0.19.0‑cp27‑cp27m‑win_amd64.whl)


## Credits & Contributing

Jesper	Holmström

Daniel	Jonsson

Filip	Polbratt

Olav	Nilsson

Linnea	Lundström

Sebastian Ragnarsson

Anton	Forsberg

Karl	Andersson

Niklas Carlsson